package client.clientState;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.net.URL;


import client.graphics.GraphicObjectFactory;
import client.graphics.ViewFacade;
import client.network.NetworkHandlerMain;

import com.golden.gamedev.Game;
import com.golden.gamedev.GameLoader;
import com.golden.gamedev.object.background.ColorBackground;

public class ClientGameLoop extends Game{

	public ClientGameLoop(){
		distribute = false;//Set true to remove GTGE logo and FPS counter
		
		
	}
	/**
	 * Initializes resources, is run before update and render begins. 
	 * Inherited from the GTGE framework.
	 */
	public void initResources() {
		//I guess this is where we start stuff?
		
		setFPS(100);
		showCursor();
		URL fileURL = GraphicObjectFactory.getInstance().getFileURL("Graphics/wowIcon.png");
		BufferedImage image = com.golden.gamedev.util.ImageUtil.getImage(fileURL, Transparency.TRANSLUCENT );
		bsGraphics.setWindowIcon(image);
		bsGraphics.setWindowTitle("World of Wisdom");
		
		NetworkHandlerMain.getInstance();
		client.UserInput.InputControls.TryInitialize(this.bsInput);
		
	}

	/**
	 * Is called by the GTGE framework to render game elements.
	 */
	public void render(Graphics2D arg0) {
		//new ColorBackground(Color.RED, 800, 600).render(arg0);
		ViewFacade.getInstance().render(arg0);
		
	}

	/**
	 * Is called by the GTGE framework to update game elements.
	 */
	public void update(long arg0) {

		StateControl.getInstance().update(arg0);
		
	}
	/**
	 * Main method of the game.
	 * @param args
	 */
	  public static void main(String[] args) {
	        GameLoader game = new GameLoader();
	        
	        Game theGame = new ClientGameLoop();
	      
	        game.setup(theGame, new Dimension(800,600), false);
	        game.start();
	        
	    }

}
