package client.clientState.loginMenuState;

import java.util.ArrayList;
import java.util.Stack;

import client.clientState.GameState;
import client.clientState.StateControl;

import shared.network.messages.LoginResult;
import shared.network.messages.Message;
import shared.network.messages.ObjectMessage;
import shared.serverHelpers.ClientKingdomInfo;
import shared.serverHelpers.ShortCharacter;
/**
 * 
 * Controls the LoginMenues. 
 */
public class LoginMenuState extends GameState {

	private Stack<LoginMenu> menuStack;
	
	public LoginMenuState(){
		
		menuStack = new Stack<LoginMenu>();
		menuStack.push(new MainLoginMenu());
		
	}
	
	@Override
	public void receivedMessage(Message msg) {
		menuStack.peek().receiveMessage(msg);

	}

	@Override
	public GameState update(long elapsedtime) {

		LoginMenu nextMenu = menuStack.peek().update();
		
		if(nextMenu != menuStack.peek()){
			if(nextMenu == null){
				menuStack.pop();
				if(menuStack.size() == 0){
					//TODO: this should indicate quitting the game!
					return null;
				}
			}
			else if(nextMenu instanceof GoToWorldDummy){
				
				return GameState.getWorldMenuState();
			
				
			}
			else{
				menuStack.push(nextMenu);
				menuStack.peek().forceRedraw();
			}
		}
		
		
		return this;

	}

	@Override
	public void forceDraw() {
		menuStack.peek().forceRedraw();
		
	}

	
	
	
	
	
	
	
	
	
	
}
