package client.clientState.worldState.playerMenu;

import client.clientState.worldState.WorldModel;
import client.graphics.GraphicObjectFactory;
import client.graphics.SpriteGraphicObject;
import client.graphics.ViewFacade;
import shared.models.PlayableCharacter;
import shared.network.messages.Message;
/**
 * Shows the main information about the Character.
 *
 */
public class MainCharacterTab extends PlayerMenuTab {

	private PlayableCharacter character;
	
	private SpriteGraphicObject characterImage;
	private SpriteGraphicObject backGround;
	
	private final int characterImageX = 10;
	private final int characterImageY = 10;
	
	private final int mainCharacteristicsX = characterImageX + 150 + 10;
	
	private final int nameY = 20;
	private final int classAndLevelY = 40;
	
	private final int attributeNumbersX = mainCharacteristicsX + 100;
	
	private final int strY = 80;
	private final int intY = 100;
	private final int dexY = 120;
	private final int conY = 140;
	
	private final int mainCharacteristicsRightX = 370;
	private final int attributeNumbersRightX = mainCharacteristicsRightX + 50;
	
	
	public MainCharacterTab(int xloc, int yloc, WorldModel worldModel) {
		super(xloc, yloc, worldModel);
		
		character = worldModel.getCharacter();
		String imageName = character.getImagePath();
		if(imageName == null){
			imageName = "head2";
		}
		backGround = GraphicObjectFactory.getInstance().buildSpriteGraphicObjectPng("MenuGraphics/PlayerMenu/maincharactertabback", xloc, yloc); 
		characterImage = GraphicObjectFactory.getInstance().buildSpriteGraphicObjectPng("heads/" + imageName + "_150", xloc + characterImageX, yloc + characterImageY);
		
	}
	
	@Override
	public void forceRedraw() {

		ViewFacade.getInstance().addMidFrontSprite(backGround);
		ViewFacade.getInstance().addForegroundSprite(characterImage);
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject(character.getName(), xLocation + mainCharacteristicsX, yLocation + nameY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject(character.getPlayerClass() + " level " + character.getLVL(), xLocation + mainCharacteristicsX, yLocation + classAndLevelY));
		
		//add the Attribute texts:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Strength : " , xLocation + mainCharacteristicsX, yLocation + strY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Dexterity : " , xLocation + mainCharacteristicsX, yLocation + dexY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Intelligence : " , xLocation + mainCharacteristicsX, yLocation + intY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Constitution : " , xLocation + mainCharacteristicsX, yLocation + conY));
		
		//add the Attribute numbers:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( "" + character.getAttribute().getSTR(), xLocation + attributeNumbersX, yLocation + strY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( "" + character.getAttribute().getDEX(), xLocation + attributeNumbersX, yLocation + dexY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( "" + character.getAttribute().getINT(), xLocation + attributeNumbersX, yLocation + intY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( "" + character.getAttribute().getCON(), xLocation + attributeNumbersX, yLocation + conY));
		
		//add the HP/MP/XP texts:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("HP : " , xLocation + mainCharacteristicsRightX, yLocation + strY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("MP : " , xLocation + mainCharacteristicsRightX, yLocation + intY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("XP : " , xLocation + mainCharacteristicsRightX, yLocation + dexY));
		
		//add the HP/MP/XP numbers:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( character.getAttribute().getHP() + " / " + character.getAttribute().getMaxHP(), xLocation + attributeNumbersRightX, yLocation + strY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( character.getAttribute().getMP() + " / " + character.getAttribute().getMaxMP(), xLocation + attributeNumbersRightX, yLocation + intY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject( " ? / ? ", xLocation + attributeNumbersRightX, yLocation + dexY));
		
	}

	@Override
	public void receiveMessage(Message msg) {
		// TODO Auto-generated method stub

	}

	@Override
	public boolean update() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void enterPressed() {
		// TODO Auto-generated method stub

	}

}
