package client.clientState.worldState.playerMenu;

import client.clientState.worldState.WorldModel;
import client.graphics.GraphicObjectFactory;
import client.graphics.SpriteGraphicObject;
import client.graphics.ViewFacade;
import shared.models.PlayableCharacter;
import shared.network.messages.Message;
/**
 * 
 * Shows the Skills of the player Character.
 */
public class SkillsTab extends PlayerMenuTab {

	private SpriteGraphicObject backGround;
	private PlayableCharacter character;
	
	
	
	private final int offSkillsTextX = 30;
	private final int offSkillsValueX = 220;
	
	private final int defSkillsTextX = 275;
	private final int defSkillsValueX = 465;
	
	private final int skillsStartY = 50;
	private final int skillsOffsetY = 20;
	
	private final int pierceY = skillsStartY + ( skillsOffsetY * 0 );
	private final int bluntY = skillsStartY + ( skillsOffsetY * 1 );
	private final int slashingY = skillsStartY + ( skillsOffsetY * 2 );
	private final int fireY = skillsStartY + ( skillsOffsetY * 3 );
	private final int waterY = skillsStartY + ( skillsOffsetY * 4 );
	private final int earthY = skillsStartY + ( skillsOffsetY * 5 );
	private final int airY = skillsStartY + ( skillsOffsetY * 6 );
	
	
	public SkillsTab(int xloc, int yloc, WorldModel worldModel) {
		super(xloc, yloc, worldModel);
		backGround = GraphicObjectFactory.getInstance().buildSpriteGraphicObjectPng("MenuGraphics/PlayerMenu/skillstabback", xloc, yloc); 
		character = worldModel.getCharacter();
	}
	
	@Override
	public void forceRedraw() {

		ViewFacade.getInstance().addMidFrontSprite(backGround);
		
		//DRAW OFFENSIVE SKILLS:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Piercing Offensive", xLocation + offSkillsTextX, yLocation + pierceY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getPiercingOff(), xLocation + offSkillsValueX, yLocation + pierceY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Blunt Offensive", xLocation + offSkillsTextX, yLocation + bluntY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getBluntOff(), xLocation + offSkillsValueX, yLocation + bluntY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Slashing Offensive", xLocation + offSkillsTextX, yLocation + slashingY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getSlashingOff(), xLocation + offSkillsValueX, yLocation + slashingY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Fire Magic Offensive", xLocation + offSkillsTextX, yLocation + fireY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getFireOff(), xLocation + offSkillsValueX, yLocation + fireY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Water Magic Offensive", xLocation + offSkillsTextX, yLocation + waterY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getWaterOff(), xLocation + offSkillsValueX, yLocation + waterY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Earth Magic Offensive", xLocation + offSkillsTextX, yLocation + earthY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getEarthOff(), xLocation + offSkillsValueX, yLocation + earthY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Air Magic Offensive", xLocation + offSkillsTextX, yLocation + airY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getAirOff(), xLocation + offSkillsValueX, yLocation + airY));
		
		//DRAW DEFENSIVE SKILLS:
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Piercing Defensive", xLocation + defSkillsTextX, yLocation + pierceY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getPiercingDef(), xLocation + defSkillsValueX, yLocation + pierceY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Blunt Defensive", xLocation + defSkillsTextX, yLocation + bluntY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getBluntDef(), xLocation + defSkillsValueX, yLocation + bluntY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Slashing Defensive", xLocation + defSkillsTextX, yLocation + slashingY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getSlashingDef(), xLocation + defSkillsValueX, yLocation + slashingY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Fire Magic Defensive", xLocation + defSkillsTextX, yLocation + fireY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getFireDef(), xLocation + defSkillsValueX, yLocation + fireY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Water Magic Defensive", xLocation + defSkillsTextX, yLocation + waterY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getWaterDef(), xLocation + defSkillsValueX, yLocation + waterY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Earth Magic Defensive", xLocation + defSkillsTextX, yLocation + earthY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getEarthDef(), xLocation + defSkillsValueX, yLocation + earthY));
		
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("Air Magic Defensive", xLocation + defSkillsTextX, yLocation + airY));
		ViewFacade.getInstance().addForegroundSprite(GraphicObjectFactory.getInstance().buildStandardTextGraphicObject("" + character.getAttribute().getAirDef(), xLocation + defSkillsValueX, yLocation + airY));
		
		
	}

	@Override
	public void receiveMessage(Message msg) {
		// TODO Auto-generated method stub

	}

	@Override
	public boolean update() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void enterPressed() {
		// TODO Auto-generated method stub

	}

}
