package client.graphics;

import java.awt.Graphics2D;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.net.URL;

import client.clientState.Settings;

import com.golden.gamedev.object.Sprite;

/**
 * Wrapper for sprite-objects implementing the GraphicObject Interface.
 */
public class SpriteGraphicObject implements GraphicObject {

	private Sprite sprite;
	
	public SpriteGraphicObject(Sprite s){
		sprite = s;
	}
	
	/**
	 * Draws the sprite.
	 */
	public void draw(Graphics2D g) {
		sprite.render(g);

	}
	/**
	 * Updates the picture used by the sprite.
	 * @param imagename
	 */
	public void updatePicture(String imagename){
		URL fileURL = GraphicObjectFactory.getInstance().getFileURL("Graphics/" + imagename + ".png");
		BufferedImage image = com.golden.gamedev.util.ImageUtil.getImage(fileURL, Transparency.TRANSLUCENT );
		sprite.setImage(image);
	}

	@Override
	public int getYLoc() {
		// TODO Auto-generated method stub
		return (int)sprite.getY();
	}

	@Override
	public int compareTo(GraphicObject o) {
		// TODO Auto-generated method stub
		return 0;
	}
	/**
	 * Set X position of the sprite.
	 * @param x
	 */
	public void setXcoord(int x){
		sprite.setX(x);
	}
	/**
	 * Set Y position of the sprite.
	 * @param y
	 */
	public void setYcoord(int y){
		sprite.setY(y);
	}
	/**
	 * Sets the position of the sprite.
	 * @param x
	 * @param y
	 */
	public void setCoords(int x, int y){
		sprite.setX(x);
		sprite.setY(y);
	}

}
