package client.graphics.components;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import shared.models.Attack;
/**
 * 
 * Buttons used in the Attack Panel.
 */
public class AttackButton extends WowButton {

	private Attack attack;
	private BufferedImage attackIcon;
	
	private final int textOffsetX = 10;
	private final int textOffsetY = 22;
	
	private final int imageOffsetX = 181;
	private final int imageOffsetY = 2;
	
	public AttackButton(BufferedImage attackImage, BufferedImage buttonDown,
			BufferedImage buttonUp, int location,	int location2,  Attack attack) {
		
		super(buttonUp, buttonDown, buttonDown, buttonUp, buttonUp,
				location, location2, true, false);
		
		this.attack = attack;
		this.attackIcon = attackImage;
	}
	
	/**
	 * Draws the attack button.
	 */
	public void draw(Graphics2D g) {
		if(getButtonState() == WowButtonState.BUTTON_UP){
			
				g.drawImage(getButtonUp(), null, getXLocation(), getYLocation());
				
			
		}
		else if(getButtonState() == WowButtonState.BUTTON_DOWN){
			
				g.drawImage(getButtonDown(), null, getXLocation(), getYLocation());
			
		}
		
		g.drawString(attack.getName(), getXLocation()+ textOffsetX, getYLocation() + textOffsetY);
		g.drawImage(attackIcon, null, getXLocation() + imageOffsetX, getYLocation() + imageOffsetY);
		
	}

	public Attack getAttack() {
		return attack;
	}

	public void setAttack(Attack attack) {
		this.attack = attack;
	}
	
	

}
