package client.graphics.components;

import java.awt.Graphics2D;
/**
 * Abstract class for Focusable components. 
 *
 */
public abstract class KeyBoardFocusableComponent extends SelectableComponent {

	protected keyBoardFocusHandler keyFocusHandler;
	protected boolean hasKeyboardFocus;
	
	public KeyBoardFocusableComponent(int xLocation, int yLocation, int width, int height,
			keyBoardFocusHandler keyFocusHandler, boolean mouseOver){
		super(xLocation, yLocation, width, height, mouseOver);
		this.keyFocusHandler = keyFocusHandler;
		keyFocusHandler.addKeyboardFocusComponent(this);
	}
	/**
	 * Requests keyboardfocus.
	 * @return
	 */
	protected boolean requestKeyBoardFocus(){
		if(keyFocusHandler.requestKeyboardFocus(this)){
			hasKeyboardFocus = true;
			return true;
		}
		else{
			hasKeyboardFocus = false;
			return false;
		}
	}
	/**
	 * Release the keyboard focus.
	 */
	public void releaseKeyboardFocus(){
		hasKeyboardFocus = false;
	}
	/**
	 * Gets the keyboard focus.
	 */
	public void receiveKeyboardFocus(){
		hasKeyboardFocus = true;
	}
	
	
	@Override
	public void draw(Graphics2D g) {
		// TODO Auto-generated method stub

	}

	@Override
	public void updateInput() {
		// TODO Auto-generated method stub

	}

}
