package client.network;

import shared.network.MessageHandler;
import shared.network.messages.Message;
import shared.network.Connection;
/**
 * Handles messages to and from the network.
 * @author thorgrun
 *
 */
public class LobbyHandler implements MessageHandler{
	private Connection conn;
	
	public LobbyHandler(String ipAdress,int portNr){
		conn = new Connection(ipAdress,portNr,this);
	}
	/**
	 * Forwards the message to NetworkHandlerMain.
	 */
	public void getMessage(Message msg) {
		NetworkHandlerMain.getInstance().getLobbyMessage(msg);
		
	}
	/**
	 * Sends message to Lobby server.
	 * @param msg
	 */
	public void sendMessage(Message msg){
		conn.sendMessage(msg);
	}
	/**
	 * Returns true if the connection is up.
	 * @return
	 */
	protected boolean isConnected(){
		return conn.isConnected();
	}
	
	/**
	 * Is called if the connection is interrupted.
	 * TODO: Implement.
	 */
	public void lostConnection() {
		
	}
}
