package client.network;

import shared.network.MessageHandler;
import shared.network.messages.Message;
import shared.network.Connection;
/**
 * Handles messages to and from the network.
 * @author thorgrun
 *
 */
public class WorldServerHandler implements MessageHandler{
	private Connection conn;
	public WorldServerHandler(String serverAdresse,int portNr){
		conn = new Connection(serverAdresse,portNr,this);
	}
	/**
	 * Forwards the message to NetworkHandlerMain.
	 */
	public void getMessage(Message msg) {
		NetworkHandlerMain.getInstance().getWorldServerMessage(msg);
	}
	/**
	 * Sends a message to the World Server.
	 * @param msg
	 */
	public void sendMessage(Message msg){
		conn.sendMessage(msg);
	}
	/**
	 * Returns true if the connection is up.
	 * @return
	 */
	protected boolean isConnected(){
		return conn.isConnected();
	}

	/**
	 * Is called if the connection is interrupted.
	 * TODO: Implement.
	 */
	public void lostConnection() {
		// TODO Auto-generated method stub
		
	}

}
