package database.databaseServer;

import java.io.IOException;
import java.net.ServerSocket;

/**
 * 
 * @author Esben Fllesdal
 * Listens for connections from the lobbyserver.
 * Creates a new thread for each connection
 */
public class WorldServerListener extends Thread {

	private ServerSocket serverSocket = null;
	private int SERVER_PORT;
	private boolean listeneing = true;
	public WorldServerListener(int listenPort){
		super("WorldServerListenerThread");
		SERVER_PORT = listenPort;
	}
	/**
	 * Starts 
	 */
	public void run(){
		try {
			serverSocket = new ServerSocket(SERVER_PORT);
			System.out.println("Listening on port:" +SERVER_PORT);
						
		} catch (IOException ioe) {
			System.out.println("Could not listen on port: "+ SERVER_PORT);
		    ioe.printStackTrace();
			System.exit(1);
		}
		
		while (listeneing )
			try {
				new WorldServerConnectionThread(serverSocket.accept()).start();
			} catch (IOException e) {
				System.out.println("Could not start a new thread");
				e.printStackTrace();
			    System.exit(1);
			}
		}
	
	
}
