package editor.graphics;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import editor.EditorMain;
/**
 * Window for creating new Kingdom.
 * Prompts the user for Name and Subject.
 * @author thorgrun
 *
 */
public class CreateKingdomWindow extends JFrame implements ActionListener, WindowListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton create;
	private JButton cancel;
	private JTextField name;
	private JTextField subjectName;
	public CreateKingdomWindow(int x,int y){
		super("Create new kingdom");
		Container content = getContentPane();
		setSize(220,90);
		setLayout(new GridLayout(3,2));
		setVisible(true);
		setResizable(false);
		create = new JButton("Create");
		create.addActionListener(this);
		setLocation(x+400,y+300);
		cancel = new JButton("Cancel");
		cancel.addActionListener(this);
		name = new JTextField(20);
		subjectName = new JTextField(20);
		content.add(new JLabel("Kingdom name:"));
		content.add(name);
		content.add(new JLabel("Subject name:"));
		content.add(subjectName);
		content.add(create);
		content.add(cancel);
		addWindowListener(this);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==create){
			
			if(EditorMain.getControls().createNewKingdom(name.getText(),subjectName.getText())){
				EditorGUI.guiControls().enableGui();
				this.dispose();
			}else{
				JOptionPane.showMessageDialog(null, "Zone with name \""+name.getText()+"\" allready exists in the kingdom. Please enter a unique name.");
			}
			
			
			
			
			
			
		}else if(e.getSource()==cancel){
			EditorGUI.guiControls().enableGui();
			this.dispose();
		}
		
	}

	@Override
	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0) {
		EditorGUI.guiControls().enableGui();
		this.dispose();
		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
