package editor.graphics.editorPanels.mapEditorPanels;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import shared.models.Location;
import shared.models.TravelTrigger;

import editor.EditorMain;
import editor.graphics.EditorGUI;
/**
 * Window for creating Travel triggers.
 * Shows input fields for Name and size.
 * @author thorgrun
 *
 */
public class CreateTriggerWindow extends JFrame implements ActionListener, WindowListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JTextField nameField;
	private JSpinner widthSpinner;
	private JSpinner heightSpinner;
	private JButton create;
	private JButton cancel;
	private String zoneName;
	
	public CreateTriggerWindow(String zoneName,int x, int y){
		
		super("Create new Travel trigger");
		this.zoneName = zoneName;
		Container content = getContentPane();
		setLocation(x+400,y+300);//Set location relative to EditorGUI
		setSize(220,130);
		setLayout(new GridLayout(4,2));
		setVisible(true);
		setResizable(false);
		//initialize components
		create = new JButton("Create");
		create.addActionListener(this);
		
		cancel = new JButton("Cancel");
		cancel.addActionListener(this);
		
		nameField = new JTextField(20);
		widthSpinner = new JSpinner(new SpinnerNumberModel(10,10,50,1));
		heightSpinner = new JSpinner(new SpinnerNumberModel(10,10,50,1));
		
		content.add(new JLabel("Trigger name:"));
		content.add(nameField);
		content.add(new JLabel("Width:"));
		content.add(widthSpinner);
		content.add(new JLabel("Height:"));
		content.add(heightSpinner);
		content.add(create);
		content.add(cancel);
		
		addWindowListener(this);
	}
	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==create){
			TravelTrigger newTrigger = new TravelTrigger(nameField.getText(),Integer.parseInt(widthSpinner.getValue()+""),Integer.parseInt(heightSpinner.getValue()+""),new Location(0,0));
			if(EditorMain.getControls().addTravelTriggerToZone(zoneName, newTrigger)){
				EditorGUI.guiControls().enableGui();
				this.dispose();
			}else{
				JOptionPane.showMessageDialog(null, "Trigger with name \""+nameField.getText()+"\" allready exists in the kingdom. Please enter a unique name.");
			}
			
			
			
			
			
			
		}else if(e.getSource()==cancel){
			EditorGUI.guiControls().enableGui();
			this.dispose();
		}
		
	}

	@Override
	public void windowActivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosed(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowClosing(WindowEvent arg0) {
		EditorGUI.guiControls().enableGui();
		this.dispose();
		
	}

	@Override
	public void windowDeactivated(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowDeiconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowIconified(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void windowOpened(WindowEvent arg0) {
		// TODO Auto-generated method stub
		
	}

}
