package editor.graphics.editorPanels.mapEditorPanels;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;

import shared.models.BackgroundTile;
import shared.models.Location;
import shared.models.Zone;

import editor.EditorMain;
import editor.graphics.EditorGUI;
/**
 * Window for creating new Zones.
 * Shows input fields for name and size.
 * @author thorgrun
 *
 */
public class CreateZoneWindow extends JFrame implements ActionListener, WindowListener{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JButton create;
	private JButton cancel;
	private JTextField name;
	private JSpinner hSize;
	private JSpinner vSize;
	
	public CreateZoneWindow(int x, int y){
		super("Create new zone");
		Container content = getContentPane();
		setSize(220,130);
		setLayout(new GridLayout(4,2));
		setVisible(true);
		setResizable(false);
		//initialize components
		create = new JButton("Create");
		create.addActionListener(this);
		setLocation(x+400,y+300);//Set location relative to EditorGUI
		cancel = new JButton("Cancel");
		cancel.addActionListener(this);
		
		name = new JTextField(20);
		hSize = new JSpinner(new SpinnerNumberModel(10,10,50,1));
		vSize = new JSpinner(new SpinnerNumberModel(10,10,50,1));
		
		content.add(new JLabel("Zone name:"));
		content.add(name);
		content.add(new JLabel("Horizontal size:"));
		content.add(hSize);
		content.add(new JLabel("Vertical size:"));
		content.add(vSize);
		content.add(create);
		content.add(cancel);
		
		addWindowListener(this);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if(e.getSource()==create){
			Zone newZone = new Zone(0+"",name.getText(),new BackgroundTile[Integer.parseInt(hSize.getValue()+"")][Integer.parseInt(vSize.getValue()+"")],new Location(10,10));
			if(EditorMain.getControls().createNewZone(newZone)){
				EditorGUI.guiControls().enableGui();
				this.dispose();
			}else{
				JOptionPane.showMessageDialog(null, "Zone with name \""+name.getText()+"\" allready exists in the kingdom. Please enter a unique name.");
			}
			
			
			
			
			
			
		}else if(e.getSource()==cancel){
			EditorGUI.guiControls().enableGui();
			this.dispose();
		}
		
	}

	@Override
	public void windowActivated(WindowEvent e) {
		
	}

	@Override
	public void windowClosed(WindowEvent e) {
	}

	@Override
	public void windowClosing(WindowEvent e) {
		EditorGUI.guiControls().enableGui();
		this.dispose();
		
	}

	@Override
	public void windowDeactivated(WindowEvent e) {
	}

	@Override
	public void windowDeiconified(WindowEvent e) {
		
	}

	@Override
	public void windowIconified(WindowEvent e) {
		
	}

	@Override
	public void windowOpened(WindowEvent e) {
		
	}


	
}
