package editor.models.changeListeners;

import shared.models.EnemyNPC;
import shared.models.FriendlyNPC;
import shared.models.StaticObject;
import shared.models.TravelTrigger;
import shared.models.Zone;

public interface WorldModelChangedListener {

	public void newEnemyNPC(String zoneName, EnemyNPC npc);
	public void newFriendlyNPC(String zoneName, FriendlyNPC npc);
	public void newStaticObject(String zoneName, StaticObject obj);
	public void newTravelTrigger(String zoneName, TravelTrigger trigger);
	public void newZone(Zone newZone);
	public void newWorld(String kingdomName);
	public void removeZone(String zoneName);
	public void removeEnemyNPC(String zoneName,int npcId);
	public void removeFriendlyNPC(String zoneName,int npcId);
	public void removeStaticObject(String zoneName, int objId);
	public void removeTravelTrigger(String zoneName, int triggerId);
	public void currentZone(Zone selectedZone);
	
}
