package lobbyServer.clientSessionHandler;

import java.io.*;
import java.util.*;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import sun.security.x509.ReasonFlags;
/**
 * This class is the command-input for the Lobbyserver, and parses commands from the
 * command line and executes them.
 */
public class LobbyCommand {

	static BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	static StringTokenizer st = new StringTokenizer("");
	//private LobbyControl ctrl;
	private boolean running;

	public LobbyCommand(){
		
		running = true;
		LobbyControl.getLobbyControl();
		
		
		readCommands();
		
	}
	
	private void readCommands(){
		while(running){
		String command;
			try {
				command = readString();
			
				if(command.equals("shutdown")){
					System.out.println("Shutdown Command Received");
					System.out.println("Shutting down");
				}
				else if(command.equals("list")){
					command = readString();
					
					if(command.equals("clients")){
						LobbyControl.getLobbyControl().printClientList();
					}
					else if(command.equals("servers")){
						LobbyControl.getLobbyControl().printServerList();
					}
					
				}
				
				else if(command.equals("kick")){
					
					command = readString();
					LobbyControl.getLobbyControl().getClientHandler(command).disconnectClient("Kicked by lobbyserver!");
				}
				
				else if(command.equals("ban")){
						
					String sessionID = readString();
					
						System.out.println("Please state the reason for the ban");
						command = stdin.readLine();
						LobbyControl.getLobbyControl().banPlayer(sessionID, command);
				}
				
				else if(command.equals("unban")){
					
					String userName = readString();
					LobbyControl.getLobbyControl().unBanPlayer(userName);
					
				}
				
				else if(command.equals("show")){
					
					command = readString();
					
					if(command.equals("banlist")){
						LobbyControl.getLobbyControl().printBanList();
					}
				}
			
			} catch (Exception e) {
				System.out.println("Command Read Error!");
			}
		}
	}
	
	
	
	public static void main(String args[]){
		JFrame frame = new JFrame("Lobby Server");
		frame.setVisible(true);
		frame.setLocation(300, 300);
		frame.setSize(200, 50);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JLabel lbl = new JLabel("Server is running..");
		frame.add(lbl);
		
		
		LobbyCommand com = new LobbyCommand();
	}

	// Read next input-token as string.
	static String readString() throws Exception {
		while (!st.hasMoreTokens()) {
			st = new StringTokenizer(stdin.readLine());
		}
		return st.nextToken();
	}

	// Read next input-token as integer.
	static int readInt() throws Exception {
		return Integer.parseInt(readString());
	}

	// Read next input-token as double.
	static double readDouble() throws Exception {
		return Double.parseDouble(readString());
	}
	
	
	
	
}
