package shared.fileHandler;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import shared.models.BackgroundTile;

import client.graphics.Background;

public class ReadBackgroundFromFile {
	
	
	public static boolean saveBackgroundToFile(int kingdomId, String zoneName, BackgroundTile[][] backgroundArray){
		//Create folder;
		 new File("Resources/Background/"+kingdomId).mkdir();
		 File backgroundFile = new File("Resources/Background/"+kingdomId+"/"+zoneName+".txt");
		  BufferedWriter output =null;
	      
	      try {
	    	  output= new BufferedWriter(new FileWriter(backgroundFile));
		      
	    	int xSize = backgroundArray.length;
	    	int ySize =0;
	    	if(xSize>0){
	    		ySize = backgroundArray[0].length;
	    	}
	    	
	    	
	    	for(int y=0;y<ySize;y++){
	    		String line1 ="";
	    		String line2 ="";
	    		for(int x =0;x<xSize;x++){
	    			line1+=backgroundArray[x][y].getTextureId().substring(0, 2);
	    			line2+=backgroundArray[x][y].getTextureId().substring(2,4);
	    		}
	    		output.write(line1);
	    		output.newLine();
	    		output.write(line2);
	    		output.newLine();
	    	}
	      }catch(IOException e){
	    	  System.err.println("Couldn't write to file :"+e.getMessage());
	      }finally {
	    	  try{
	    		  output.close();
	    	  }catch(IOException e){
	    		  System.err.println("Couldn't close filewriter.");
	    	  }
	        
	      }

		
		
		
		return true;
	}
	/**
	  * Fetch the entire contents of a text file, and return it in a String.
	  * This style of implementation does not throw Exceptions to the caller.
	  *
	  * @param aFile is a file which already exists and can be read.
	  */
	   public static BackgroundTile[][] get(String filePath,int sizeX, int sizeY) throws IOException{
		File aFile = new File("Resources/Background/"+filePath+".txt");
		BackgroundTile[][] backgroundTileArray=null;
	    
	      //use buffering, reading one line at a time
	      //FileReader always assumes default encoding is OK!
	      BufferedReader input =  new BufferedReader(new FileReader(aFile));
	      try {
	    	backgroundTileArray = new BackgroundTile[sizeX][sizeY];
	        String line = null; //not declared within while loop
	        String line2 = null;
	        int x=0;
	        int y=0;
	        while (( line = input.readLine()) != null){
	        	line2= input.readLine();
	        	for(int i = 0;i<line.length();i+=2){
	        		backgroundTileArray[x][y] = new BackgroundTile(line.substring(i, i+2)+line2.substring(i,i+2));
	        	
	        		x++;
	        	}
	        	x=0;
	        	y++;
	        }
	      }
	      finally {
	        input.close();
	      }
	    
	    return backgroundTileArray;
	  }
}
