package shared.fileHandler;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import shared.models.BackgroundTile;

public class Settings {

	private static String STR_LOBBYIP = "LobbyIP";
	private static String STR_LOBBYPORT = "LobbyPort";
	private static String STR_DATABASEIP = "DatabaseIP";
	private static String STR_DATABASEPORT = "DatabasePort";
	private static String STR_CLIENTLISTENPORT = "ClientListenPort";
	private static String STR_WORLDSERVERLISTENPORT = "WorldServerListenPort";
	private static String STR_EDITORLISTENPORT = "EditorListenPort";
	private static String STR_LOBBYLISTENPORT = "LobbyListenPort";
	private static String STR_POSTGRESQLIP = "PostgreSqlIp";
	private static String STR_DATABASENAME = "DatabaseName";
	
	private String lobbyIp; 
	private int lobbyPort; 
	private String databaseIp; 
	private int databasePort; 
	private int clientListenPort; 
	private int worldServerListenPort;
	private int editorListenPort; 
	private int lobbyListenPort;
	private String postgreSQLIp;



	private String databaseName;


	public Settings(String fileName){
		try{
			readSettingsFromFile(fileName);
		}catch(IOException e){
			System.err.println("Could not read file:"+fileName);
		}
		
	}
	
	
	
	private void readSettingsFromFile(String fileName) throws IOException{
		File aFile = new File("Resources/Settings/"+fileName+".ini");
		BackgroundTile[][] backgroundTileArray=null;
	 
	      //use buffering, reading one line at a time
	      //FileReader always assumes default encoding is OK!
	      BufferedReader input =  new BufferedReader(new FileReader(aFile));
	      try {
	    	  boolean linesLeft = true;
	    	 
	    	  while(linesLeft){
	    		  String line = input.readLine();
	    		  if(line!=null){
	    			  setVariable(line);
	    		  }else{
	    			  linesLeft = false;
	    		  }
	    		  
	     
	        }
	      }
	      finally {
	        input.close();
	      }
	    
		
		
		
		
	}
	
	
	
	private void setVariable(String line){
		String[] splitLine = line.split("=");
		if(splitLine.length==2){
			if(splitLine[0].toLowerCase().equals(STR_LOBBYIP.toLowerCase())){
				lobbyIp = splitLine[1];
			}else if(splitLine[0].toLowerCase().equals(STR_LOBBYPORT.toLowerCase())){
				lobbyPort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_DATABASEIP.toLowerCase())){
				databaseIp = splitLine[1];
			}else if(splitLine[0].toLowerCase().equals(STR_DATABASEPORT.toLowerCase())){
				databasePort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_CLIENTLISTENPORT.toLowerCase())){
				clientListenPort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_WORLDSERVERLISTENPORT.toLowerCase())){
				worldServerListenPort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_EDITORLISTENPORT.toLowerCase())){
				editorListenPort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_LOBBYLISTENPORT.toLowerCase())){
				lobbyListenPort = Integer.parseInt(splitLine[1]);
			}else if(splitLine[0].toLowerCase().equals(STR_POSTGRESQLIP.toLowerCase())){
				postgreSQLIp = splitLine[1];
			}else if(splitLine[0].toLowerCase().equals(STR_DATABASENAME.toLowerCase())){
				databaseName =splitLine[1];
			}
		}
	}
	

	public String getLobbyIp() {
		return lobbyIp;
	}



	public int getLobbyPort() {
		return lobbyPort;
	}



	public String getDatabaseIp() {
		return databaseIp;
	}



	public int getDatabasePort() {
		return databasePort;
	}



	public int getClientListenPort() {
		return clientListenPort;
	}



	public int getWorldServerListenPort() {
		return worldServerListenPort;
	}



	public int getEditorListenPort() {
		return editorListenPort;
	}



	public int getLobbyListenPort() {
		return lobbyListenPort;
	}
	public String getPostgreSQLIp() {
		return postgreSQLIp;
	}



	public String getDatabaseName() {
		return databaseName;
	}

}
