package shared.fileHandler;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import shared.models.Zone;


/**
 * Saves and loads zone objects from a harddrive.
 * @author thorgrun
 *
 */
public class ZoneFileHandler {
	
	
	public static void saveZone(Zone zone){
		FileOutputStream f_out;
		try {
			f_out = new FileOutputStream (zone.getZoneId()+".zone");
		
			ObjectOutputStream obj_out = new
		    ObjectOutputStream (f_out);

			obj_out.writeObject(zone);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("FileNotFoundException:"+e.getMessage());
		}catch(IOException e){
			System.out.println("IOException:"+e.getMessage());
		}
	
	}
	public static Zone loadZone(String zoneId){
	
		// Read from disk using FileInputStream.
		FileInputStream f_in;
		try {
			f_in = new FileInputStream(zoneId+".zone");
	
		
			ObjectInputStream obj_in = new ObjectInputStream (f_in);
		
			Object obj = obj_in.readObject ();
		
		
			if (obj instanceof Zone)
			{
				return (Zone) obj;
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			System.out.println("FileNotFoundException:"+e.getMessage());
		}catch(ClassNotFoundException e){
			System.out.println("ClassNotFoundException:"+e.getMessage());
		}catch(IOException e){
			System.out.println("IOException:"+e.getMessage());
		}
		return null;
	}
	public static void main(String[] args){
//		ZoneLite thaZone = new ZoneLite("twilightZone",500);
//		saveZone(thaZone);
		
		Zone temp = loadZone("twilightZone");
		System.out.println(temp.getZoneId());
	}
}
