package shared.models;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * Holds the attributes for a Character.
 *
 */
public class Attributes implements Serializable {

	private static final long serialVersionUID = 1L;
	private int HP;
	private int MP;
	private int STR;
	private int INT ;
	private int DEX;
	private int CON;
	private int maxHP;
	private int maxMP;
	private int piercingDef;
	private int bluntDef;
	private int slashingDef;
	private int fireDef;
	private int waterDef;
	private int earthDef;
	private int airDef;
	private int piercingOff;
	private int bluntOff;
	private int slashingOff;
	private int fireOff;
	private int waterOff;
	private int earthOff;
	private int airOff;
	
	private ArrayList<AttributeListener> attributeListeners;
	
	public Attributes(int HP, int MP, int STR, int INT, int DEX,int CON, int maxHP,
			int maxMP, int piercingDef, int bluntDef, int slashingDef, int fireDef,
			int waterDef, int earthDef, int airDef, int piercingOff, int bluntOff, 
			int slashingOff, int fireOff, int waterOff, int earthOff, int airOff){
		this.HP = HP;
		this.MP = MP;
		this.STR = STR;
		this.INT = INT;
		this.DEX = DEX;
		this.CON = CON;
		this.maxHP = maxHP;
		this.maxMP = maxMP;
		this.piercingDef = piercingDef;
		this.bluntDef = bluntDef;
		this.slashingDef = slashingDef;
		this.fireDef = fireDef;
		this.waterDef = waterDef;
		this.earthDef = earthDef;
		this.airDef = airDef;
		this.piercingOff = piercingOff;
		this.bluntOff = bluntOff;
		this.slashingOff = slashingOff;
		this.fireOff = fireOff;
		this.waterOff = waterOff;
		this.earthOff = earthOff;
		this.airOff = airOff;
		
		
	}
	
	public void addAttributeListener(AttributeListener a){
		attributeListeners.add(a);
	}
	
	public void removeAttributeListener(AttributeListener a){
		attributeListeners.remove(a);
	}
	
	public void fireAttributeChanged(AttributeTypes attributeType, int oldValue, int newValue){
		for (AttributeListener a : attributeListeners) {
			a.AttributeChanged(attributeType, oldValue, newValue);
		}
	}
	
	public Attributes(){
		this.attributeListeners = new ArrayList<AttributeListener>();
	}

	public int getHP() {
		return HP;
	}

	public void setHP(int hp) {
		int oldval = HP;
		HP = hp;
		fireAttributeChanged(AttributeTypes.HP, oldval, hp);
	}

	public int getMP() {
		return MP;
	}

	public void setMP(int mp) {
		int oldval = MP;
		MP = mp;
		fireAttributeChanged(AttributeTypes.MP, oldval, mp);
	}

	public int getSTR() {
		return STR;
	}

	public void setSTR(int str) {
		STR = str;
	}

	public int getINT() {
		return INT;
	}

	public void setINT(int int1) {
		INT = int1;
	}

	public int getDEX() {
		return DEX;
	}

	public void setDEX(int dex) {
		DEX = dex;
	}

	public int getCON() {
		return CON;
	}

	public void setCON(int con) {
		CON = con;
	}

	public int getMaxHP() {
		return maxHP;
	}

	public void setMaxHP(int maxHP) {
		int oldval = this.maxHP;
		this.maxHP = maxHP;
		fireAttributeChanged(AttributeTypes.MAX_HP, oldval, maxHP);
	}

	public int getMaxMP() {
		return maxMP;
	}

	public void setMaxMP(int maxMP) {
		int oldval = this.maxMP;
		this.maxMP = maxMP;
		fireAttributeChanged(AttributeTypes.MAX_MP, oldval, maxMP);
	}

	public int getPiercingDef() {
		return piercingDef;
	}

	public void setPiercingDef(int piercingDef) {
		this.piercingDef = piercingDef;
	}

	public int getBluntDef() {
		return bluntDef;
	}

	public void setBluntDef(int bluntDef) {
		this.bluntDef = bluntDef;
	}

	public int getSlashingDef() {
		return slashingDef;
	}

	public void setSlashingDef(int slashingDef) {
		this.slashingDef = slashingDef;
	}

	public int getFireDef() {
		return fireDef;
	}

	public void setFireDef(int fireDef) {
		this.fireDef = fireDef;
	}

	public int getWaterDef() {
		return waterDef;
	}

	public void setWaterDef(int waterDef) {
		this.waterDef = waterDef;
	}

	public int getEarthDef() {
		return earthDef;
	}

	public void setEarthDef(int earthDef) {
		this.earthDef = earthDef;
	}

	public int getAirDef() {
		return airDef;
	}

	public void setAirDef(int airDef) {
		this.airDef = airDef;
	}

	public int getPiercingOff() {
		return piercingOff;
	}

	public void setPiercingOff(int piercingOff) {
		this.piercingOff = piercingOff;
	}

	public int getBluntOff() {
		return bluntOff;
	}

	public void setBluntOff(int bluntOff) {
		this.bluntOff = bluntOff;
	}

	public int getSlashingOff() {
		return slashingOff;
	}

	public void setSlashingOff(int slashingOff) {
		this.slashingOff = slashingOff;
	}

	public int getFireOff() {
		return fireOff;
	}

	public void setFireOff(int fireOff) {
		this.fireOff = fireOff;
	}

	public int getWaterOff() {
		return waterOff;
	}

	public void setWaterOff(int waterOff) {
		this.waterOff = waterOff;
	}

	public int getEarthOff() {
		return earthOff;
	}

	public void setEarthOff(int earthOff) {
		this.earthOff = earthOff;
	}

	public int getAirOff() {
		return airOff;
	}

	public void setAirOff(int airOff) {
		this.airOff = airOff;
	}
	
	public ArrayList<AttributeTypes> getNotZeroAttributes(){
		ArrayList<AttributeTypes> list = new ArrayList<AttributeTypes>();
		if(HP != 0){
			list.add(AttributeTypes.HP);
		}
		if(MP != 0){
			list.add(AttributeTypes.MP);
		}
		if(STR != 0){
			list.add(AttributeTypes.STR);
		}
		if(INT != 0){
			list.add(AttributeTypes.INT);
		}
		if(DEX != 0){
			list.add(AttributeTypes.DEX);
		}
		if(CON != 0){
			list.add(AttributeTypes.CON);
		}
		if(maxHP != 0){
			list.add(AttributeTypes.MAX_HP);
		}
		if(maxMP != 0){
			list.add(AttributeTypes.MAX_MP);		
		}
		if(piercingDef != 0){
			list.add(AttributeTypes.PIERCING_DEF);
		}
		if(bluntDef != 0){
			list.add(AttributeTypes.BLUNT_DEF);	
		}
		if(slashingDef != 0){
			list.add(AttributeTypes.SLASHING_DEF);
		}
		if(fireDef != 0){
			list.add(AttributeTypes.FIRE_DEF);
		}
		if(waterDef != 0){
			list.add(AttributeTypes.WATER_DEF);
		}
		if(earthDef != 0){
			list.add(AttributeTypes.EARTH_DEF);
		}
		if(airDef != 0){
			list.add(AttributeTypes.AIR_DEF);
		}
		if(piercingOff != 0){
			list.add(AttributeTypes.PIERCING_OFF);
		}
		if(bluntOff != 0){
			list.add(AttributeTypes.BLUNT_OFF);
		}
		if(slashingOff != 0){
			list.add(AttributeTypes.SLASHING_OFF);
		}
		if(fireOff != 0){
			list.add(AttributeTypes.FIRE_OFF);
		}
		if(waterOff != 0){
			list.add(AttributeTypes.WATER_OFF);
		}
		if(earthOff != 0){
			list.add(AttributeTypes.EARTH_OFF);
		}
		if(airOff != 0){
			list.add(AttributeTypes.AIR_OFF);
		}
			

		return list;
	}
	
	
	/**
	 * Helper method for getting the value of an attribute by attributetype
	 * 
	 * @param attributeType the attributetype you are interested in
	 * @return the value of the specific attribute
	 */
	public int getValueFromAttributeType(AttributeTypes attributeType){
		if(attributeType == AttributeTypes.HP){
			return getHP();
		}
		else if(attributeType == AttributeTypes.MP){
			return getMP();
		}
		else if(attributeType == AttributeTypes.STR){
			return getSTR();
		}
		else if(attributeType == AttributeTypes.INT){
			return getINT();
		}
		else if(attributeType == AttributeTypes.DEX){
			return getDEX();
		}
		else if(attributeType == AttributeTypes.CON){
			return getCON();
		}
		else if(attributeType == AttributeTypes.MAX_HP){
			return getMaxHP();
		}
		else if(attributeType == AttributeTypes.MAX_MP){
			return getMaxMP();
		}
		else if(attributeType == AttributeTypes.PIERCING_DEF){
			return getPiercingDef();
		}
		else if(attributeType == AttributeTypes.BLUNT_DEF){
			return getBluntDef();
		}
		else if(attributeType == AttributeTypes.SLASHING_DEF){
			return getSlashingDef();
		}
		else if(attributeType == AttributeTypes.FIRE_DEF){
			return getFireDef();
		}
		else if(attributeType == AttributeTypes.WATER_DEF){
			return getWaterDef();
		}
		else if(attributeType == AttributeTypes.EARTH_DEF){
			return getEarthDef();
		}
		else if(attributeType == AttributeTypes.AIR_DEF){
			return getAirDef();
		}
		else if(attributeType == AttributeTypes.PIERCING_OFF){
			return getPiercingOff();
		}
		else if(attributeType == AttributeTypes.BLUNT_OFF){
			return getBluntOff();
		}
		else if(attributeType == AttributeTypes.SLASHING_OFF){
			return getSlashingOff();
		}
		else if(attributeType == AttributeTypes.FIRE_OFF){
			return getFireOff();
		}
		else if(attributeType == AttributeTypes.WATER_OFF){
			return getWaterOff();
		}
		else if(attributeType == AttributeTypes.EARTH_OFF){
			return getEarthOff();
		}
		else if(attributeType == AttributeTypes.AIR_OFF){
			return getAirOff();
		}
		return 0;
	}
}
