package shared.models;

import java.io.Serializable;
import java.util.ArrayList;

import shared.models.SimpleCharacter.CharacterType;


/**
 * 
 * @author Esben Fllesdal
 * @see Character
 * @see Serializable
 */
public class EnemyNPC extends Character implements Serializable {

	private static final long serialVersionUID = 1L;
	private int levelOfAgressivenes;
	private int sleepTime;
	private int XP;
	private int enemyNPCId;
	private String topicTheme;
	private String targetId;//Id of their current target that they will attack at regular intervals
	public String getTargetId() {
		return targetId;
	}


	public void setTargetId(String targetId) {
		this.targetId = targetId;
	}


	public EnemyNPC(String name, Gender sex, int LVL,
			Attributes attribute,
			int levelOfAgressivenes, int sleepTime,
			int XP,
			ArrayList<Attack>magicalAttackList, ArrayList<Attack>physicalAttackList,
			String imagePath) {
		super(name, sex, LVL,  attribute,  magicalAttackList,physicalAttackList, imagePath);
		this.levelOfAgressivenes = levelOfAgressivenes;
		this.sleepTime = sleepTime;
		this.XP = XP;
		this.topicTheme = "";
	}

	public SimpleCharacter getSimpleCharacter(){
		SimpleCharacter simpleCha =  new SimpleCharacter(getName(),getImagePath(),CharacterType.ENEMY_NPC,
				getLVL(),getAttribute().getHP(),getAttribute().getMP(),
				getAttribute().getMaxHP(),getAttribute().getMaxMP());
		simpleCha.setCurrentLocationReference(getCurrentLocation());
		simpleCha.setTargetLocationReference(getTargetLocation());
		return simpleCha;
	}
	public int getLevelOfAgressivenes() {
		return levelOfAgressivenes;
	}


	public void setLevelOfAgressivenes(int levelOfAgressivenes) {
		this.levelOfAgressivenes = levelOfAgressivenes;
	}

	public EnemyNPC getCopy(){
		return new EnemyNPC(getName(),getSex(),getLVL(),getAttribute(),getLevelOfAgressivenes(),getSleepTime(),getXP(),getListOfMagicalAttacks(),getListOfPhysicalAttacks(),getImagePath());
	}
	public int getSleepTime() {
		return sleepTime;
	}


	public void setSleepTime(int sleepTime) {
		this.sleepTime = sleepTime;
	}

	public int calculateDamage(){
		return (int)(Math.random()*10)+10;
	}
	public int getXP() {
		return XP;
	}


	public void setXP(int xp) {
		XP = xp;
	}


	public int getEnemyNPCId() {
		return enemyNPCId;
	}


	public void setEnemyNPCId(int enemyNPCId) {
		this.enemyNPCId = enemyNPCId;
	}


	public String getTopicTheme() {
		return topicTheme;
	}


	public void setTopicTheme(String topicTheme) {
		this.topicTheme = topicTheme;
	}
}

