package shared.models;

import java.io.Serializable;
import java.util.ArrayList;

import shared.models.SimpleCharacter.CharacterType;

/**
 * 
 * @author Esben Fllesdal
 * @see Character
 * @see Serializable
 */
public class FriendlyNPC extends Character implements Serializable {

	private static final long serialVersionUID = 1L;
	private ArrayList<Quest> questList;
	private ArrayList<Item> buyingItemList;
	private ArrayList<Item> sellingItemList;
	private ArrayList<Dialog> dialogList;
	private int friendlyNPCId;
	
	public FriendlyNPC(String name, Gender sex, int LVL,
			Attributes attribute,
			ArrayList<Quest> questList, ArrayList<Item> buyingItemList,
			ArrayList<Item> sellingItemList, ArrayList<Dialog> dialogList,
			ArrayList<Attack>magicalAttackList, ArrayList<Attack>physicalAttackList, 
			String imagePath) {
		super(name, sex, LVL,  attribute, magicalAttackList, physicalAttackList, imagePath);
		this.questList = questList;
		this.buyingItemList = buyingItemList;
		this.sellingItemList = sellingItemList;
		this.dialogList = dialogList;
		
	}

	public FriendlyNPC getCopy(){
		return new FriendlyNPC(getName(),getSex(),getLVL(),getAttribute(),getQuestList(),getBuyingItemList(),getSellingItemList(),getDialogList(),getListOfMagicalAttacks(),getListOfPhysicalAttacks(),getImagePath());
	}
	public ArrayList<Quest> getQuestList() {
		return questList;
	}

	public void setQuestList(ArrayList<Quest> questList) {
		this.questList = questList;
	}

	public ArrayList<Item> getBuyingItemList() {
		return buyingItemList;
	}

	public void setBuyingItemList(ArrayList<Item> buyingItemList) {
		this.buyingItemList = buyingItemList;
	}

	public ArrayList<Item> getSellingItemList() {
		return sellingItemList;
	}

	public void setSellingItemList(ArrayList<Item> sellingItemList) {
		this.sellingItemList = sellingItemList;
	}

	public ArrayList<Dialog> getDialogList() {
		return dialogList;
	}

	public void setDialogList(ArrayList<Dialog> dialogList) {
		this.dialogList = dialogList;
	}

	public int getFriendlyNPCId() {
		return friendlyNPCId;
	}
	public SimpleCharacter getSimpleCharacter(){
		SimpleCharacter simpleCha =  new SimpleCharacter(getName(),getImagePath(),CharacterType.FRIENDLY_NPC,
				getLVL(),getAttribute().getHP(),getAttribute().getMP(),
				getAttribute().getMaxHP(),getAttribute().getMaxMP());
		simpleCha.setCurrentLocationReference(getCurrentLocation());
		simpleCha.setTargetLocationReference(getTargetLocation());
		return simpleCha;
	}
	public void setFriendlyNPCId(int friendlyNPCId) {
		this.friendlyNPCId = friendlyNPCId;
	}
}
