package shared.models;

import java.io.Serializable;

/**
 * This class contains a itemObject. This is the parrentclass to
 * weapon, armour and useableItem 
 * @author Esben Fllesdal
 * @see Weapon
 * @see Armour
 * @see UseableItem
 */
public class Item implements Serializable{

	private static final long serialVersionUID = 1L;
	private String name;
	private Attributes attribute;
	private Attributes requiredAttribute;
	private int range;
	private int price;
	private Effect effect;
	private EquipLocation equipLocation = null;
	private int itemId;
	private String imagePath;
		
	public Item(int itemId, String name, Attributes attribute, int range, int price,
			Attributes requiredAttribute, Effect effect, String imagePath, 
			EquipLocation equipLocation){
		this.name = name;
		this.attribute = attribute;
		this.range  = range;
		this.price = price;
		this.requiredAttribute = requiredAttribute;
		this.effect = effect;
		this.itemId = itemId;
		this.imagePath = imagePath;
		this.equipLocation = equipLocation;
	}

	public String getImagePath() {
		return imagePath;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Attributes getAttribute() {
		return attribute;
	}

	public int getItemId() {
		return itemId;
	}

	public void setItemId(int itemId) {
		this.itemId = itemId;
	}

	public void setAttribute(Attributes attribute) {
		this.attribute = attribute;
	}

	public Attributes getRequiredAttribute() {
		return requiredAttribute;
	}

	public void setRequiredAttribute(Attributes requiredAttribute) {
		this.requiredAttribute = requiredAttribute;
	}

	public int getRange() {
		return range;
	}

	public void setRange(int range) {
		this.range = range;
	}

	public int getPrice() {
		return price;
	}

	public void setPrice(int price) {
		this.price = price;
	}

	public Effect getEffect() {
		return effect;
	}

	public void setEffect(Effect effect) {
		this.effect = effect;
	}

	public EquipLocation getEquipLocation() {
		return equipLocation;
	}

	public void setEquipLocation(EquipLocation equipLocation) {
		this.equipLocation = equipLocation;
	}
}