package shared.models;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * This class will contain a questionObject
 * @author Esben Fllesdal
 * @see Answer
 */
public class Question implements Serializable{

	private static final long serialVersionUID = 1L;
	private int questionID;
	private ArrayList<Answer> answers;
	private String questionText;
	private String questionHeading;
	private String questionTopic;
	private int questionLevel;
	private int timeLimit;
	
	/**
	 * 
	 * @param questionId - the databaseId
	 * @param answers - All the possible answers to the question
	 * @param questionText - The question text
	 * @param questionHeading - a qestionHeading
	 */
	public Question(int questionId, ArrayList<Answer> answers, String questionText,
			String questionHeading, String questionTopic, int questionLevel, int timeLimit){
		this.questionID = questionId;
		this.answers = answers;
		this.questionText = questionText;
		this.questionHeading = questionHeading;
		this.questionTopic = questionTopic;
		this.questionLevel = questionLevel;
		this.timeLimit = timeLimit;
	}

	public int getTimeLimit() {
		return timeLimit;
	}

	public void setTimeLimit(int timeLimit) {
		this.timeLimit = timeLimit;
	}

	public String getQuestionTopic() {
		return questionTopic;
	}

	public void setQuestionTopic(String questionTopic) {
		this.questionTopic = questionTopic;
	}

	public int getQuestionID() {
		return questionID;
	}

	public void setQuestionID(int questionID) {
		this.questionID = questionID;
	}

	public ArrayList<Answer> getAnswers() {
		return answers;
	}

	public void setAnswers(ArrayList<Answer> answers) {
		this.answers = answers;
	}

	public String getQuestionText() {
		return questionText;
	}

	public void setQuestionText(String questionText) {
		this.questionText = questionText;
	}

	public String getQuestionHeading() {
		return questionHeading;
	}

	public void setQuestionHeading(String questionHeading) {
		this.questionHeading = questionHeading;
	}
	
	public int getQuestionLevel() {
		return questionLevel;
	}



	public void setQuestionLevel(int questionLevel) {
		this.questionLevel = questionLevel;
	}



	public String toString(){
		return this.questionHeading;
	}
}
