package shared.models;

import java.io.Serializable;

/**
 * Holds information about a Static object.
 *
 */
public class StaticObject extends WorldObject implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Location placement;
	private String textureId;
	private int staticObjectId;
	private String name;//Any need for name/identifier?
	private int imageWidth;
	private int imageHeight;
	public StaticObject(String name,String textureId,Location placement){
		this.name = name;
		this.textureId = textureId;
		this.placement = placement;
		this.imageWidth = 0;
		this.imageHeight = 0;
	}
	public String getName() {
		return name;
	}
	public Location getCurrentLocation() {
		return placement;
	}
	public String getTextureId() {
		return textureId;
	}
	public void setStaticObjectId(int id){
		this.staticObjectId = id;
	}
	public int getStaticObjectId(){
		return staticObjectId;
	}
	public int getImageHeight() {
		return imageHeight;
	}
	public int getImageWidth() {
		return imageWidth;
	}
	public void setCurrentLocation(Location location) {
		this.placement= location;
		
	}
	public StaticObject getCopy(){
		return new StaticObject(getName(),getTextureId(),getCurrentLocation());
	}
	public void setImageHeight(int height) {
		this.imageHeight = height;
		
	}
	public void setImageWidth(int width) {
		this.imageWidth = width;
	}
	public String toString(){
		return name;
	}
	
}
