package shared.models;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * 
 * @author Esben Fllesdal
 * @see PlayableCharacter
 * @see Serializable
 */
public class Student extends PlayableCharacter implements Serializable {

	private static final long serialVersionUID = 1L;
	private KnowledgeBook knowledgeBook;
	private QuestJournal questJournal;
	
	public Student(String name, Gender sex, int LVL,
			Attributes attribute, 
			ArrayList<Item> inventory, int playerId,
			PlayableClasses playerClass, String respawnPoint, int money,
			ArrayList<Attack> physicalAttackList,
			ArrayList<Attack> magicalAttackList,
			KnowledgeBook knowledgeBook, QuestJournal questJournal,
			String imagePath,
			Item equipedItemHead, Item equipedItemLeftRing,	Item equipedItemRightRing,
			Item equipedItemLeftArm, Item equipedItemRightArm,	Item equipedItemBody,
			Item equipedItemLegs, Item equipedItemAmulet, int XP) {
		super(name, sex, LVL,  attribute, inventory, playerId, playerClass,
				respawnPoint, money, physicalAttackList, magicalAttackList, imagePath,
				equipedItemHead,  equipedItemLeftRing,	 equipedItemRightRing,
				 equipedItemLeftArm,  equipedItemRightArm,	 equipedItemBody,
				 equipedItemLegs,  equipedItemAmulet, XP);
		this.knowledgeBook = knowledgeBook;
		this.questJournal = questJournal;
	}

	public KnowledgeBook getKnowledgeBook() {
		return knowledgeBook;
	}

	public void setKnowledgeBook(KnowledgeBook knowledgeBook) {
		this.knowledgeBook = knowledgeBook;
	}

	public QuestJournal getQuestJournal() {
		return questJournal;
	}

	public void setQuestJournal(QuestJournal questJournal) {
		this.questJournal = questJournal;
	}
	
	
}
