package shared.models;

import java.io.Serializable;
/**
 * Information about a useable item. Inherits from Item.
 *
 */
public class UseableItem extends Item implements Serializable {

	private static final long serialVersionUID = 1L;
	private UseableItemType useableItemType;
	
	public UseableItem(int itemId, String name, Attributes attribute, int range,
			int price, Attributes requiredAttribute, Effect effect,
			UseableItemType useableItemType, String imagePath, EquipLocation equipLocation) {
		super(itemId, name, attribute, range, price, requiredAttribute, effect, imagePath, 
				equipLocation);
		this.useableItemType = useableItemType;
	}

	public UseableItemType getUseableItemType() {
		return useableItemType;
	}

	public void setUseableItemType(UseableItemType useableItemType) {
		this.useableItemType = useableItemType;
	}
}