package shared.models;

import java.io.Serializable;

import com.sun.org.apache.bcel.internal.generic.Select;
/**
 * Information on a weapon. Inherits from Item.
 */
public class Weapon extends Item implements Serializable {


	private static final long serialVersionUID = 1L;
	private WeaponType weaponType;
	private boolean twoHand;
	private int damage;

	public Weapon(int itemId, String name, Attributes attribute, int range,
			int price, Attributes requiredAttribute, Effect effect, 
			WeaponType weaponType, boolean twoHand, int damage, String imagePath, 
			EquipLocation equipLocation) {
		super(itemId, name, attribute, range, price, requiredAttribute, effect, imagePath, equipLocation);
		this.weaponType = weaponType;
		this.twoHand = twoHand;
		this.damage = damage;
	}

	public WeaponType getWeaponType() {
		return weaponType;
	}

	public void setWeaponType(WeaponType weaponType) {
		this.weaponType = weaponType;
	}

	public boolean isTwoHand() {
		return twoHand;
	}

	public int getDamage() {
		return damage;
	}

	public void setTwoHand(boolean twoHand) {
		this.twoHand = twoHand;
	}
	
	public DamageType getDamageType(){
		switch (getWeaponType()) {
		case BOW:
			return DamageType.PIERCING;
		case NATRUAL_PIERCING:
			return DamageType.PIERCING;
		case SPEAR:
			return DamageType.PIERCING;
		case SWORD:
			return DamageType.SLASHING;
		case AXE:
			return DamageType.SLASHING;
		case DAGGER:
			return DamageType.SLASHING;
		case NATRUAL_SLASHING:
			return DamageType.PIERCING;
		case NATRUAL_BLUNT:
			return DamageType.BLUNT;
		case CLUB:
			return DamageType.BLUNT;
		case MACE:
			return DamageType.BLUNT;
		case STAFF:
			return DamageType.BLUNT;
		case WEAPON:
			//TODO: find a logic way to select damage when this is selected 
			return DamageType.BLUNT;		
		}
		return DamageType.BLUNT;
	}
}