package shared.models;

/**
 * 
 * Information of a WorldObject. 
 * All drawed objects in the gameworld inherits from this class.
 */
public abstract class WorldObject{
	public abstract Location getCurrentLocation();
	public abstract String getName();
	public abstract void setCurrentLocation(Location location);
	public abstract void setImageWidth(int width);
	public abstract void setImageHeight(int height);
	public abstract int getImageHeight();
	public abstract int getImageWidth();
	public int getCollisionWidth(){
		
		if(getName().equals("Oak Tree")){
			return 20;
		}
		return getImageWidth();
	}
	public int getCollisionHeight(){
		if(getName().equals("Oak Tree")){
			return 20;
		}else if(getName().equals("Unicorn")){
			return 5;
		}
		return getImageHeight();
	}
	public boolean withinBounds(Location position){
		double leftMostObjectPosX = getCurrentLocation().getXDouble()-getCollisionWidth()/2;
		double rightMostObjectPosX = getCurrentLocation().getXDouble()+getCollisionWidth()/2;
		double topY = getCurrentLocation().getYDouble();
		double bottomY = getCurrentLocation().getYDouble()-getCollisionHeight();
		if(position.getX()>leftMostObjectPosX&&position.getX()<rightMostObjectPosX){
			if(position.getY()>bottomY&&position.getY()<topY){
				return true;
			}
		}
		return false;
	}

}
