package shared.models.helpers;

import shared.models.AgressiveLevel;
import shared.models.AttackType;
import shared.models.AttributeTypes;
import shared.models.DamageType;
import shared.models.EquipLocation;
import shared.models.Gender;
import shared.models.PlayableClasses;
import shared.models.UseableItem;
import shared.models.UseableItemType;
import shared.models.WeaponType;
/**
 * This class contains metods to help figure out which enum a string belongs to  
 * @author Esben Fllesdal
 * 
 */
public class EnumHelpers {

	/**
	 * 
	 * @param playableClassString - a string that needs to be translated into  a 
	 * playablClass enum
	 * @return a playableClass object
	 * @see PlayableClasses
	 */
	public static PlayableClasses GetPlayableClass(String playableClassString){
		if(playableClassString.equals("FIGHTER")||(playableClassString.equals("fighter"))){
			return PlayableClasses.FIGHTER;
		}
		else if(playableClassString.equals("MAGE")||(playableClassString.equals("mage"))){
			return PlayableClasses.MAGE;
		}
		else if(playableClassString.equals("RANGER")||(playableClassString.equals("ranger"))){
			return PlayableClasses.RANGER;
		}
		else if(playableClassString.equals("ALL")||(playableClassString.equals("all"))){
			return PlayableClasses.ALL;
		}
		return null;
	}
	/**
	 * 
	 * @param weaponTypeString- a string that needs to be translated into  a 
	 * weaponType enum
	 * @return a weaponType
	 * @see WeaponType
	 */
	public static WeaponType GetWeaponType(String weaponTypeString){
		if(weaponTypeString.equals("BOW")){
			return WeaponType.BOW;
		}
		else if(weaponTypeString.equals("NATRUAL_PIERCING")){
			return WeaponType.NATRUAL_PIERCING;
		}
		else if(weaponTypeString.equals("SPEAR")){
			return WeaponType.SPEAR;
		}
		else if(weaponTypeString.equals("SWORD")){
			return WeaponType.SWORD;
		}
		else if(weaponTypeString.equals("AXE")){
			return WeaponType.AXE;
		}
		else if(weaponTypeString.equals("DAGGER")){
			return WeaponType.DAGGER;
		}
		else if(weaponTypeString.equals("NATRUAL_SLASHING")){
			return WeaponType.NATRUAL_SLASHING;
		}
		else if(weaponTypeString.equals("NATRUAL_BLUNT")){
			return WeaponType.NATRUAL_BLUNT;
		}
		else if(weaponTypeString.equals("CLUB")){
			return WeaponType.CLUB;
		}
		else if(weaponTypeString.equals("MACE")){
			return WeaponType.MACE;
		}
		else if(weaponTypeString.equals("STAFF")){
			return WeaponType.STAFF;
		}
		else if(weaponTypeString.equals("WEAPON")){
			return WeaponType.WEAPON;
		}
		return null;
	}
	
	/**
	 * 
	 * @param genderString a string that needs to be translated into  a gender enum
	 * @return a gender enum
	 * @see Gender
	 */
	public static Gender GetGender(String genderString){
		if(genderString.equals("M")){
			return Gender.MALE;
		}
		else if(genderString.equals("F")){
			return Gender.FEMALE;
		}
		return null;
	}
	
	/**
	 * 
	 * @param agressiveString - a string that needs to be translated into a gender enum
	 * @return a agressiveLevel enum
	 * @see AgressiveLevel
	 */
	public static AgressiveLevel GetAgressiveLeve(String agressiveString){
		if(agressiveString.equals("NONE")){
			return AgressiveLevel.NONE;
		}
		else if(agressiveString.equals("LOW")){
			return AgressiveLevel.LOW;
		}
		else if(agressiveString.equals("MEDIUM")){
			return AgressiveLevel.MEDIUM;
		}
		else if(agressiveString.equals("HIGH")){
			return AgressiveLevel.HIGH;
		}
		return null;
	}
	
	/**
	 * 
	 * @param damageTypeString -a string that needs to be translated into a damageType enum
	 * @return a damageType enum
	 * @see DamageType
	 */
	public static DamageType GetDamageType(String damageTypeString){
		if(damageTypeString.equals("SLASHING")){
			return DamageType.SLASHING;
		}
		else if(damageTypeString.equals("BLUNT")){
			return DamageType.BLUNT;
		}
		else if(damageTypeString.equals("PIERCING")){
			return DamageType.PIERCING;
		}
		else if(damageTypeString.equals("FIRE")){
			return DamageType.FIRE;
		}
		else if(damageTypeString.equals("WATER")){
			return DamageType.WATER;
		}
		else if(damageTypeString.equals("AIR")){
			return DamageType.AIR;
		}
		else if(damageTypeString.equals("EARTH")){
			return DamageType.EARTH;
		}
		else if(damageTypeString.equals("ALL")){
			return DamageType.ALL;
		}
		return null;
	}
	
	/**
	 * 
	 * @param equipLocationString - a string that needs to be translated into a equipLocation
	 * @return a equiplocation enum
	 * @see EquipLocation
	 */
	public static  EquipLocation GetEquipLocation(String equipLocationString){
		if(equipLocationString.equals("LEFT_ARM")){
			return EquipLocation.LEFT_ARM;
		}
		else if(equipLocationString.equals("RIGTH_ARM")){
			return EquipLocation.RIGHT_ARM;
		}
		else if(equipLocationString.equals("ARM")){
			return EquipLocation.ARM;
		}
		else if(equipLocationString.equals("HEAD")){
			return EquipLocation.HEAD;
		}
		else if(equipLocationString.equals("LEGS")){
			return EquipLocation.LEGS;
		}
		else if(equipLocationString.equals("BODY")){
			return EquipLocation.BODY;
		}
		else if(equipLocationString.equals("RIGHT_RING")){
			return EquipLocation.RIGHT_RING;
		}
		else if(equipLocationString.equals("LEFT_RING")){
			return EquipLocation.LEFT_RING;
		}
		else if(equipLocationString.equals("RING")){
			return EquipLocation.RING;
		}
		else if(equipLocationString.equals("AMULET")){
			return EquipLocation.AMULET;
		}
		else if(equipLocationString.equals("BACKPACK")){
			return EquipLocation.BACKPACK;
		}
		return null;
	}
	
	/**
	 * 
	 * @param attackTypeString - a string that needs to be translated into a attackType
	 * @return a attackTypeEnum
	 * @see AttackType
	 */
	public static AttackType GetAttackType(String attackTypeString){
		if(attackTypeString.equals("PHYSICAL")){
			return AttackType.PHYSICAL;
		}
		else if(attackTypeString.equals("MAGICAL")){
			return AttackType.MAGICAL;
		}
		return null;
	}
	
	/**
	 * 
	 * @param attributeTypeString -a string that needs to be translated into a attributetype
	 * @return a attributeTypeEnum
	 * @see AttributeTypes
	 */
	public static AttributeTypes GetAttributeType(String attributeTypeString){
		if(attributeTypeString.equals("HP")){
			return AttributeTypes.HP;
		}
		else if(attributeTypeString.equals("MP")){
			return AttributeTypes.MP;
		}
		else if(attributeTypeString.equals("STR")){
			return AttributeTypes.STR;
		}
		else if(attributeTypeString.equals("INT")){
			return AttributeTypes.INT;
		}
		else if(attributeTypeString.equals("DEX")){
			return AttributeTypes.DEX;
		}
		else if(attributeTypeString.equals("CON")){
			return AttributeTypes.CON;
		}
		else if(attributeTypeString.equals("MAX_HP")){
			return AttributeTypes.MAX_HP;
		}
		else if(attributeTypeString.equals("MAX_MP")){
			return AttributeTypes.MAX_MP;
		}
		else if(attributeTypeString.equals("PIERCING_DEF")){
			return AttributeTypes.PIERCING_DEF;
		}
		else if(attributeTypeString.equals("BLUNT_DEF")){
			return AttributeTypes.BLUNT_DEF;
		}
		else if(attributeTypeString.equals("SLASHING_DEF")){
			return AttributeTypes.SLASHING_DEF;
		}
		else if(attributeTypeString.equals("FIRE_DEF")){
			return AttributeTypes.FIRE_DEF;
		}
		else if(attributeTypeString.equals("WATER_DEF")){
			return AttributeTypes.WATER_DEF;
		}
		else if(attributeTypeString.equals("EARTH_DEF")){
			return AttributeTypes.EARTH_DEF;
		}
		else if(attributeTypeString.equals("AIR_DEF")){
			return AttributeTypes.AIR_DEF;
		}
		else if(attributeTypeString.equals("PIERCING_OFF")){
			return AttributeTypes.PIERCING_OFF;
		}
		else if(attributeTypeString.equals("BLUNT_OFF")){
			return AttributeTypes.BLUNT_OFF;
		}
		else if(attributeTypeString.equals("SLASHING_OFF")){
			return AttributeTypes.SLASHING_OFF;
		}
		else if(attributeTypeString.equals("FIRE_OFF")){
			return AttributeTypes.FIRE_OFF;
		}
		else if(attributeTypeString.equals("WATER_OFF")){
			return AttributeTypes.WATER_OFF;
		}
		else if(attributeTypeString.equals("EARTH_OFF")){
			return AttributeTypes.EARTH_OFF;
		}
		else if(attributeTypeString.equals("AIR_OFF")){
			return AttributeTypes.AIR_OFF;
		}
		
		return null;
	}
	
	/**
	 * 
	 * @param useableItemTypeString -a string that needs to be translated into a useableItemType
	 * @return a useableItemType
	 * @see UseableItem
	 */
	public  static UseableItemType GetUseableItemType(String useableItemTypeString){
		if(useableItemTypeString.equals("KEY")){
			return UseableItemType.KEY;
		}
		else if(useableItemTypeString.equals("KNOWLWDGE_SCROLL")){
			return UseableItemType.KNOWLWDGE_SCROLL;
		}
		else if(useableItemTypeString.equals("MAGIC_SCROLL")){
			return UseableItemType.MAGIC_SCROLL;
		}
		else if(useableItemTypeString.equals("PERMANENT_POTION")){
			return UseableItemType.PERMANENT_POTION;
		}
		else if(useableItemTypeString.equals("TEMPORARY_POTION")){
			return UseableItemType.TEMPORARY_POTION;
		}
		else if(useableItemTypeString.equals("TOOL")){
			return UseableItemType.TOOL;
		}
		return null;
	}
}