package shared.network;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;

/**
 * Network server that listens for new connections.
 * @author thorgrun
 *
 */
public class NetworkServer implements Runnable{

	private Thread listenForConnectionThread;
	private int serverPort;
	private ConnectionListener connListener;
	public NetworkServer(int serverPort, ConnectionListener connListener){
		this.serverPort = serverPort;
		this.connListener = connListener;
		listenForConnectionThread = new Thread(this);
		listenForConnectionThread.start();
	}
	
	
	/**
	 * Listens for a connection.
	 */
	public void run() {
		try{
			ServerSocket listenSocket =new ServerSocket(serverPort);;
			while(true) {
				//try {
					System.out.println("Listening");
					connListener.newConnectionReceived(listenSocket.accept());
					System.out.println("Connected");
				//} catch(IOException e) {System.out.println("Connection:"+e.getMessage());}
			}
		} catch(IOException e) {System.out.println("ListenException :"+e.getMessage());}
	}
}
