package shared.network.messages;

import java.util.ArrayList;
import java.util.HashMap;

import shared.models.Zone;

public class KingdomMessage extends Message{
	
	private String kingdomName;
	private int kingdomId;
	private String subjectName;
	private String startZoneName;
	private ArrayList<String> playerAccessList; //List of player with access to kingdom
	private HashMap<String,Zone> zoneList;
	public KingdomMessage(String kingdomName, String subjectName, int kingdomId,HashMap<String,Zone> zoneList,String startZoneName,ArrayList<String> playerAccessList,
			String message,String sourceId, String targetId) {
		super(sourceId, targetId, message, MessageType.KINGDOM_OBJECT);
		this.kingdomId = kingdomId;
		this.kingdomName = kingdomName;
		this.subjectName = subjectName;
		this.startZoneName = startZoneName;
		this.playerAccessList = playerAccessList;
		this.zoneList = zoneList;
	}

	public String getStartZoneName(){
		return startZoneName;
	}
	public String getKingdomName() {
		return kingdomName;
	}
	public ArrayList<String> getPlayerAccessList(){
		return playerAccessList;
	}

	public int getKingdomId() {
		return kingdomId;
	}


	public String getSubjectName() {
		return subjectName;
	}


	public HashMap<String, Zone> getZoneList() {
		return zoneList;
	}


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

}
