package shared.network.messages;
import java.io.*;
import java.util.ArrayList;

import shared.network.messages.actions.MovementMessage;

/**
 * 
 * Plain message, other messages inherits from this class.
 */
public class Message implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String sourceId;
	private String targetId;
	private String message;
	private MessageType messageType;
	


	public Message(String sourceId,String targetId,String message,MessageType messageType){
		this.sourceId= sourceId;
		this.targetId= targetId;
		this.message = message;
		this.messageType = messageType;
	}
	
	public String getSourceId() {
		return sourceId;
	}
	public void setSourceId(String sourceId) {
		this.sourceId = sourceId;
	}
	public void setTargetId(String targetId) {
		this.targetId = targetId;
	}
	public String getTargetId() {
		return targetId;
	}
	
	public String getMessage() {
		return message;
	}
	
	public MessageType getMessageType() {
		return messageType;
	}
	


	public void printMessage(){
		if(this instanceof MovementMessage){
			MovementMessage msg = (MovementMessage)this;
			System.out.println("MovementMessage:"+msg.getActionId()+" FromLocation:"+msg.getCurrentLocation()+" ToLocation:"+msg.getTargetLocation());
		}else{
			System.out.println(sourceId+" says: "+message+". To "+targetId);
		}
		
	}
}
