package shared.network.messages;
/** Enum for types of message that can be sent over the network.
 * 
 * @author thorgrun
 *
 */
public enum MessageType {
	   LOGIN, 					//Client logs in to Lobbyserver (C -> L)
	   LOGOUT, 					//Client logs out from Lobbyserver (C -> L)
	   LOGIN_RESULT,			//Lobbyserver responds to Client login (L -> C)
	   GET_PLAYER,				//Lobbyserver requests player details from DB (L -> DB)
	   REQUEST_SHORT_CHARACTERS, //Lobbyserver requests short-character list from DB (L -> DB)
	   REQUEST_KINGDOM_ACCESS,	//Lobbyserver requests list with access to different servers for a player
	   REQUEST_MOVEMENT, 
	   REQUEST_ZONE,
	   MOVEMENT_RESPONSE, 
	   UPDATE_PLAYER_POS,
	   EQUIP,
	   DELETE_ITEM,
	   ANSWER_QUESTION,
	   ATTACK,
	   QUESTION_RESPONSE,
	   COMBAT_RESULT,
	   ENEMY_ATTACK,
	   EQUIP_RESULT,
	   REQUEST_CHATLIST,
	   JOIN_CHANNEL,
	   CREATE_CHANNEL,
	   RETURN_CHATLIST,
	   CREATE_CHANNEL_RESPONSE,
	   JOIN_CHANNEL_RESPONSE,
	   CHATMESSAGE,
	   CLOSE_CONNECTION, 		//Servers initiates a closing of a connection (L -> DB), (L -> C)
	   PLAYER_OBJECT,
	   CREATE_PLAYER,
	   ALTER_PLAYER,
	   CONNECTION_CLOSED,
	   UNKNOWN_MESSAGE,
	   OBJECT_MESSAGE,
	   GET_PLAYABLE_CHARACTER, 		  //message to return a character. (L -> WS)		
	   ILLEGAL_DATABASE_OPERATION, 	//message from databaseserver (DB -> L)
	   SUCCESSFUL_DATBASE_OPERATION, // message from databaseServer (DB->L)
	   SUCCESSFUL_DATABASE_OPERATION_ENEMYNPC,
	   SUCCESSFUL_DATABASE_OPERATION_FRIENDLYNPC, 
	   SUCCESSFUL_DATABASE_OPERATION_STATICOBJECT,
	   SUCCESSFUL_DATABASE_OPERATION_KINGDOM,
	   SUCCESSFUL_DATABASE_OPERATION_QUESTION,
	   SUCCESSFUL_DATABASE_OPERATION_ZONETEMPLATE,
	   GET_BAN_LIST, // message to databaseserver, will return the banned players(DB -> L)
	   BAN_PLAYER, 	//this message bans a player (L->DB)
	   UNBAN_PLAYER, // unbans a player(L->DB)
	   REGISTER_SERVER,		//connects a server to the lobbyserver (WS -> L)
	   REGISTER_RESULT,		//result of registration to lobbyserver (L -> WS)
	   PLAYER_VERIFICATION_RESULT, //result of a player verfication. (L -> WS)
	   VERIFY_PLAYER, //From worldserver to lobbyserver, to verify if player can join. (WS -> L) 
	   LOBBYSERVER_REQUEST_FAILURE,	//sent when the lobbyserver fails to respond to a message (L -> WS)
	   GET_KINGDOM_ACCESSLIST,		//returns a list that 
	   ACTION_MESSAGE, //action message that tells what action has been performed, and by who
	   GET_ALL_ENEMY_NPCS, //requests all enemyNPCs from db (WS-> DB)
	   GET_ALL_FRIENDLY_NPCS, //requests all friendlyNPCS from db
	   GET_ALL_STATIC_OBJECTS, //Requests all static objects from DB
	   GET_ENEMY_NPC, 	//requests an enemyNPC from db (WS->DB)
	   GET_KINGDOM,
	   GET_ZONE_TEMPLATE,
	   CREATE_ENEMY_NPC, //Add new enemy npc to db
	   GET_ALL_QUESTIONS,	//makes a request to get all questions from the database
	   GET_ALL_TOPICS,
	   GET_ALL_KINGDOMNAMES, //Requests all kingdom names
	   GET_ALL_PLAYERNAMES,
	   GET_ALL_ZONENAMES,
	   QUESTION_MESSAGE, 	//contains a questionMessage
	   REQUEST_QUESTION,		//requests a question from the world server
	   NEW_PLAYABLE_CHARACTER,	//creates a playableCharacter
	   KINGDOM_OBJECT, //Sends all kingdom information, including lists of zones
	   DATABASE_ALTER,
	   DATABASE_INSERT,
	   DATABASE_DELETE,
	   GET_ALL_MAGICAL_ATTACKS, //Returns list of all magical attacks in database.
	   GET_ALL_PHYSICAL_ATTACKS, //REturns list of all physical attacks in database.
}
