package shared.network.messages;

import java.io.Serializable;

import shared.models.PlayableCharacter;

/**
 * This message will contain infomation needed to create a new playableCharacter in the 
 * database
 * @author Esben Fllesdal
 * @see Message
 * @see PlayableCharacter
 */
public class NewPlayableCharacterMessage extends Message implements Serializable{

	private static final long serialVersionUID = 1L;
	private PlayableCharacter playableCharacter;
	private String playerName;
	private String kingdomName;
	private String sessionId;
	
	public NewPlayableCharacterMessage(String sourceId, String targetId,
			String message, PlayableCharacter playableCharacter,
			String playerName, String kingdomName, String sessionId) {
		super(sourceId, targetId, message, MessageType.NEW_PLAYABLE_CHARACTER);
		this.playableCharacter = playableCharacter;
		this.playerName = playerName;
		this.kingdomName = kingdomName;
		this.sessionId = sessionId;
	}

	public PlayableCharacter getPlayableCharacter() {
		return playableCharacter;
	}

	public String getPlayerName() {
		return playerName;
	}

	public String getKingdomName() {
		return kingdomName;
	}

	public String getSessionId() {
		return sessionId;
	}

}
