package shared.network.messages;

import java.io.Serializable;
import java.util.ArrayList;

import shared.models.Question;

/**
 * This class will be used to send questions from server to client
 * @author Esben Fllesdal
 * @see Question
 */
public class QuestionMessage extends Message implements Serializable{

	private static final long serialVersionUID = 1L;
	private int id;
	private int timeLimit;
	private String questionText;
	private String questionHeader;
	private ArrayList<String> answers;
	
	public QuestionMessage(String sourceId, String targetId, String message,
			int id, int timeLimit, String questionText, String questionHeder, 
			ArrayList<String> answer) {
		super(sourceId, targetId, message, MessageType.QUESTION_MESSAGE);
		this.id = id;
		this.timeLimit = timeLimit;
		this.questionText = questionText;
		this.questionHeader = questionHeder;
		this.answers = answer;
		for(String str:answer){
			System.out.println(str);
		}
	}


	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public int getTimeLimit() {
		return timeLimit;
	}

	public void setTimeLimit(int timeLimit) {
		this.timeLimit = timeLimit;
	}

	public String getQuestionText() {
		return questionText;
	}

	public void setQuestionText(String questionText) {
		this.questionText = questionText;
	}

	public String getQuestionHeader() {
		return questionHeader;
	}

	public void setQuestionHeader(String questionHeader) {
		this.questionHeader = questionHeader;
	}

	public ArrayList<String> getAnswers() {
		return answers;
	}

	public void setAnswers(ArrayList<String> answers) {
		this.answers = answers;
	}
}