package shared.network.messages;

import java.io.Serializable;

import shared.models.Attack;

/**
 * This message will be sent to request a question
 * @author Esben Fllesdal
 * @see Message
 * @see Serializable
 */
public class RequestQuestionMessage extends Message implements Serializable{

	private static final long serialVersionUID = 1L;
	private Attack attack;
	private String attackTargetId;
	
	public RequestQuestionMessage(String sourceId, String targetId,
			String message, Attack attack, String attackTargetId) {
		super(sourceId, targetId, message, MessageType.REQUEST_QUESTION);
		this.attack = attack;
		this.attackTargetId = attackTargetId;
	}

	public Attack getAttack() {
		return attack;
	}

	public String getAttackTargetId() {
		return attackTargetId;
	}

	
}
