package shared.network.messages;

import java.io.Serializable;

/**
 * This message contains a sessionId, in addition to a basic message
 * @author Esben Fllesdal
 *
 */
public class SessionIdMessage extends Message implements Serializable{

	private static final long serialVersionUID = 1L;
	private String sessionID;
	private String characterName;
	
	public SessionIdMessage(String sourceId, String targetId, String message,
			MessageType messageType, String sessionId, String characteName) {
		super(sourceId, targetId, message, messageType);
		this.sessionID = sessionId;
		this.characterName = characteName;
	}

	public String getCharacterName() {
		return characterName;
	}

	public void setCharacterName(String characterName) {
		this.characterName = characterName;
	}

	public String getSessionID() {
		return sessionID;
	}

	public void setSessionID(String sessionID) {
		this.sessionID = sessionID;
	}
	


}
