package shared.network.messages.actions;

import shared.network.messages.Message;
import shared.network.messages.MessageType;
/**
 * ActionMessage - Action performed by npc or players.
 * @author thorgrun
 *
 */
public class ActionMessage extends Message{
	private String actionId; //Id of the object/client that performs the action
	private ActionType actionType;
	public ActionMessage(String sourceId, String targetId, String message,
			String actionId,ActionType actionType) {
		super(sourceId, targetId, message, MessageType.ACTION_MESSAGE);
		this.actionId = actionId;
		this.actionType = actionType;
	}
	public ActionType getActionType(){
		return actionType;
	}
	public String getActionId() {
		return actionId;
	}

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

}
