package shared.network.messages.actions;

import shared.models.EquipLocation;
import shared.models.Item;

/**
 * Message sent from client to server when he equips / unequips an item.
 * If targetlocation is BACKPACK, this means an unequip.
 * 
 * @author Henka
 *
 */
public class EquipMessage extends ActionMessage{

	private EquipLocation targetlocation;
	private EquipLocation oldlocation;
	
	public EquipMessage(String sourceId, String targetId, String message, String actionId, EquipLocation targetlocation, 
				EquipLocation oldlocation) {
		super(sourceId, targetId, message, actionId,ActionType.EQUIP);

		this.targetlocation = targetlocation;
		this.oldlocation = oldlocation;
		
	}

}
