package shared.network.messages.actions;

import java.io.Serializable;

import shared.network.messages.Message;
import shared.network.messages.MessageType;

/**
 * This class will contain an answer, sent from the client to the worldServer
 * @author Esben Fllesdal
 *
 */
public class SendAnswerMessage extends Message implements Serializable {

	private static final long serialVersionUID = 1L;
	private int answerId;
	private String answerText;
	private int timeLeft = 0;
	
	public SendAnswerMessage(String sourceId, String targetId, String message,
			int answerId, String answerText, int timeLeft) {
		super(sourceId, targetId, message, MessageType.ANSWER_QUESTION);
			this.answerId = answerId;
			this.answerText =answerText;
			this.timeLeft = timeLeft;
	}

	public int getAnswerId() {
		return answerId;
	}

	public void setAnswerId(int answerId) {
		this.answerId = answerId;
	}

	public String getAnswerText() {
		return answerText;
	}

	public void setAnswerText(String answerText) {
		this.answerText = answerText;
	}

	public int getTimeLeft() {
		return timeLeft;
	}

	
}
