package shared.serverHelpers;

import java.io.Serializable;
import java.util.ArrayList;
/**
 * 
 * Holds information about characters and a World Server for a client.
 */
public class ClientKingdomInfo implements Serializable{

	private WorldServer serverInfo;
	private ArrayList<ShortCharacter> characters;
	private String status;
	
	public ClientKingdomInfo(WorldServer serverInfo, String status){
		this.serverInfo = serverInfo;
		this.status = status;
		characters = new ArrayList<ShortCharacter>();
	}
	
	public void addCharacter(ShortCharacter c){
		characters.add(c);
	}
	
	public ShortCharacter getCharacter(int i){
		return characters.get(i);
	}

	public WorldServer getServerInfo() {
		return serverInfo;
	}

	public void setServerInfo(WorldServer serverInfo) {
		this.serverInfo = serverInfo;
	}

	public ArrayList<ShortCharacter> getCharacters() {
		return characters;
	}

	public void setCharacters(ArrayList<ShortCharacter> characters) {
		this.characters = characters;
	}

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}
	
	
	
}
