package shared.serverHelpers;

import java.io.Serializable;

import shared.models.Character;
import shared.models.Gender;
import shared.models.PlayableClasses;

/**
 * 
 * @author Esben Fllesdal
 * @see Character
 * A class to represent a small set of the character stats.
 */
public class ShortCharacter implements Serializable{

	private static final long serialVersionUID = 1L;
	private String name;
	private int LVL;
	private String kingdomKey;
	private PlayableClasses characterClass;
	private Gender sex;
	public ShortCharacter(String name, int LVL,
			String kingdomKey, PlayableClasses characterClass, Gender sex){
		this.name = name;
		this.LVL = LVL;
		this.kingdomKey = kingdomKey;
		this.characterClass = characterClass;
		this.sex = sex;
	}

	public Gender getSex() {
		return sex;
	}

	public void setSex(Gender sex) {
		this.sex = sex;
	}

	public PlayableClasses getCharacterClass() {
		return characterClass;
	}

	public void setCharacterClass(PlayableClasses characterClass) {
		this.characterClass = characterClass;
	}

	public String getKingdomKey() {
		return kingdomKey;
	}

	public void setKingdomKey(String kingdomKey) {
		this.kingdomKey = kingdomKey;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getLVL() {
		return LVL;
	}

	public void setLVL(int lvl) {
		LVL = lvl;
	}
}