package worldServer.gameLoop;

import shared.models.Character;
import shared.models.EventType;
/**
 * Holds a type of event and an event target. 
 * Type of event can be - Respawn, Attack and similar
 * that effects a creature or player after a given time period.
 * @author thorgrun
 */
public class Event {

	private Character eventTarget;
	private EventType typeOfEvent;
	/**
	 * Creates an event with eventTarget and type of event.
	 * @param eventTarget
	 * @param typeOfEvent
	 */
	public Event(Character eventTarget,EventType typeOfEvent){
		this.eventTarget = eventTarget;
		this.typeOfEvent = typeOfEvent;
	}
	/**
	 * Returns type of event
	 * @return
	 */
	public EventType getTypeOfEvent() {
		return typeOfEvent;
	}

	/**
	 * Runs the event on the event target
	 */
	public void runEvent(){
		eventTarget.runEvent(typeOfEvent);
	}
	/**
	 * Returns the target of the event
	 * @return
	 */
	public Character getEventTarget() {
		return eventTarget;
	}

}
