package worldServer.gameLoop;
/**
 * Controls the updateLoop for the GameLoops.
 * @author thorgrun
 */
public class UpdateController implements Runnable{
	private GameLoopInterface listener;
	private long elapsedTime;
	private Long totalElapsedTime;
	private long lastLoop;
	private boolean running;
	/**
	 * Creates an UpdateController
	 * @param listener GameLoop
	 */
	public UpdateController(GameLoopInterface listener){
		this.listener = listener;
		elapsedTime = 0;
		lastLoop = System.currentTimeMillis();
		running = true;
		totalElapsedTime = System.currentTimeMillis();
		new Thread(this).start();
	}
	/**
	 * Returns the time elapsed since the zone was created. (Server started)
	 * @return int
	 */
	public int getTotalElapsedTimeInSec(){
		return ((int)System.currentTimeMillis()-totalElapsedTime.intValue())/1000;
	}
	/**
	 * Runs update in the GameLoop.
	 */
	public void run() {
		while(running){
		    elapsedTime = System.currentTimeMillis()-lastLoop;
		   
		    lastLoop = System.currentTimeMillis();
			listener.update(elapsedTime);
			try {
				if(elapsedTime<35){
					Thread.sleep(20);
				}
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
